import pygame
from random import *
from spritesheet import *
from pygame.locals import *

class Cactus(pygame.sprite.Sprite):
	def __init__(self, spritesheet):
		pygame.sprite.Sprite.__init__(self)	
		self.random = Random()
		self.random.seed()
		
		self.image = pygame.surface.Surface((64, 64))
		self._images = spritesheet.get_image(Rect((0, 128), (320, 64)))
		self.start()
		
	def start(self):
		self.frozen_time = 100
		self.rect = Rect((self.random.randint(0, 9) * 64, (self.random.randint(0, 9) * 64)), (64, 64))
		self.animation = self.frozen = 0
		self.health = self.frozen_time = 100
		
	def update(self):
		if self.frozen == 0:
			if self.animation < 30 and self.health > 0 and self.frozen == 0:
				self.animation += 1
			elif self.animation > 0 and self.health < 0 and self.frozen == 0:
				self.animation -= 1
			self.health -= 0.5

			s_rect = Rect(((self.animation / 10) * 64, 0), (64, 64))
			self.image.blit(self._images, (0, 0), s_rect)
			self.image.set_colorkey(self.image.get_at((0, 0)), RLEACCEL)
			if self.health < -25: self.start()
		else:
			self.frozen_time -= 1
			if self.frozen_time <= 0:
				self.frozen = 0
				self.frozen_time = 100
		
	def freeze(self):
		self.frozen = 1
		s_rect = Rect((4 * 64, 0), (64, 64))
		self.image.blit(self._images, (0, 0), s_rect)
		self.image.set_colorkey(self.image.get_at((0, 0)), RLEACCEL)