import pygame
from random import *
from pygame.locals import *

class Dragon(pygame.sprite.Sprite):
	def __init__(self, spritesheet):
		pygame.sprite.Sprite.__init__(self)
		self.random = Random()
		self.random.seed()
		
		self._images = spritesheet.get_image(Rect((320, 128), (128, 64)))
		self.image = pygame.surface.Surface((64, 64))
		
		self.bullet_damage = 30
		self.speed = 2
		
		self.reset()
		
	def reset(self):
		side = self.random.randint(0, 4)
		sx, sy = 20, 20
		if side == 0:
			sy = 20
			sx = self.random.randint(20, 556)
		elif side == 1:
			sx = 556
			sy = self.random.randint(20, 556)
		elif side == 2:
			sy = 556
			sx = self.random.randint(20, 556)
		elif side == 3:
			sx = 20
			sy = self.random.randint(20, 556)
		self.image.blit(self._images, (0, 0), Rect((0, 0), (64, 64)))
		self.image.set_colorkey(self.image.get_at((0, 0)), RLEACCEL)
		self.rect = Rect((sx, sy), (64, 64))
		self.health = 100
		self.direction = self.frozen = 0
		self.change_direction = 30
		self.seek_in = 0
		self.shoot_timer = 100
		self.frozen_time = 100
	
	def update(self, hero_pos, fireball):
		if self.rect.top < 20:
			self.rect.top = 20
		elif self.rect.top > 556:
			self.rect.top = 556
		if self.rect.left < 20:
			self.rect.left = 20
		elif self.rect.left > 556:
			self.rect.left = 556
			
		if self.frozen == 0:
			hx, hy = hero_pos
			x, y = self.rect.topleft
			self.change_direction -= 1
			if self.change_direction <= 0:
				self.change_direction = 30
				self.seek_in = self.random.randint(0, 2)
			if  self.rect.top >= hy and self.rect.top <= hy + 64:
				if hx > x: self.direction = 1
				elif hx < x: self.direction = 3
			elif self.rect.left >= hx and self.rect.left <= hx + 64:
				if hy > y: self.direction = 2
				elif hy < y: self.direction = 0
			else:
				if self.seek_in == 0:
					if hx > x: self.direction = 1
					elif hx <= x: self.direction = 3
				elif self.seek_in == 1:
					if hy > y: self.direction = 2
					elif hy <= y: self.direction = 0
							
			if self.direction == 0: self.rect.top -= self.speed
			elif self.direction == 1: self.rect.left += self.speed
			elif self.direction == 2: self.rect.top += self.speed
			elif self.direction == 3: self.rect.left -= self.speed
				
			if self.shoot_timer > 0:
				self.shoot_timer -= 1
			else:
				self.shoot_timer = 100
				fireball.shoot(self.rect, self.direction)
		else:
			self.frozen_time -= 1
			if self.frozen_time <= 0:
				self.frozen_time = 100
				self.frozen = 0
				self.image.blit(self._images, (0, 0), Rect((0, 0), (64, 64)))
				self.image.set_colorkey(self.image.get_at((0, 0)), RLEACCEL)
				self.health = 100
			
	def shot(self):
		self.health -= self.bullet_damage
		if self.direction == 0: self.rect.move_ip(0, 40)
		elif self.direction == 1: self.rect.move_ip(-40, 0)
		elif self.direction == 2: self.rect.move_ip(0, -40)
		elif self.direction == 3: self.rect.move_ip(40, 0)
		if self.health <= 0:
			self.image.blit(self._images, (0, 0), Rect((64, 0), (64, 64)))
			self.image.set_colorkey(self.image.get_at((0, 0)), RLEACCEL)
			self.frozen = 1