import pygame
from pygame.locals import *
from spritesheet import *

class Hero(pygame.sprite.Sprite):
	def __init__(self, spritesheet):
		pygame.sprite.Sprite.__init__(self)
		
		self.direction = 2
		self.moving = (0, 0)
		
		self.image = pygame.surface.Surface((64, 64))
		self._images = spritesheet.get_image(Rect((0, 0), (256, 64)))
		self.rect = Rect((298, 298), (64, 64))
		self.health = 100
		self.bullets = 1
		self.speed = 4
		self.melting = self.animation = 0
		self.score = 0
		self.invisible = False
		self.invincible_time = 0
		
	def update(self):
		if self.invincible_time > 0:
			self.invincible_time -= 1
			self.invisible = not self.invisible
		# 0 = north, 1 = east, 2 = south, 3 = west
		if self.melting == 1: self.do_melt()
		else:
			x, y = self.rect.left, self.rect.top
			if self.moving[1] == 1:
				if self.direction == 0:
					if y > 20:
						self.rect.move_ip(0, -self.speed)
				elif self.direction == 2:
					if y < 556:
						self.rect.move_ip(0, self.speed)
			if self.moving[0] == 1:
				if self.direction == 1:
					if x < 556:
						self.rect.move_ip(self.speed, 0)
				elif self.direction == 3:
					if x > 20:
						self.rect.move_ip(-self.speed, 0)
			
			if not self.invisible:
				s_rect = Rect((self.direction * 64, 0), (64, 64))
				self.image.blit(self._images, (0, 0), s_rect)
				self.image.set_colorkey(self.image.get_at((0, 0)), RLEACCEL)
			else:
				self.image.fill((0, 0, 0))
				self.image.set_colorkey(self.image.get_at((0, 0)), RLEACCEL)
		
	def ouch(self):
		self.invincible_time = 50
		if self.direction == 0: self.rect.move_ip(0, 40)
		elif self.direction == 1: self.rect.move_ip(-40, 0)
		elif self.direction == 2: self.rect.move_ip(0, -40)
		elif self.direction == 3: self.rect.move_ip(40, 0)
			
		if self.rect.top < 20: self.rect.top = 20
		elif self.rect.top > 556: self.rect.top = 556
		
		if self.rect.left < 20: self.rect.left = 20
		elif self.rect.left > 556: self.rect.left = 556
	
	def start_melt(self, spritesheet):
		self.melting = 1
		self._images = spritesheet.get_image(Rect((0, 192), (320, 64)))
		self.rect.top = self.rect.left = 320 - 32
		
	def do_melt(self):
		if self.animation == 1: pygame.time.delay(1000)
		if self.animation < 120:
			self.animation += 1
			s_rect = Rect((64 * (self.animation / 15), 0), (64, 64))
			self.image.blit(self._images, (0, 0), s_rect)
			self.image.set_colorkey(self.image.get_at((0, 0)), RLEACCEL)
		
	
		