import pygame
from pygame.locals import *

class IceCreamBeam(pygame.sprite.Sprite):
	def __init__(self, spritesheet):
		pygame.sprite.Sprite.__init__(self)
		
		self.rect = Rect((-64, -64), (64, 64))
		s_rect = Rect((256, 0), (64, 64))
		self.image = spritesheet.get_image(s_rect)
		self.image.set_colorkey(self.image.get_at((0, 0)), RLEACCEL)
		self.shot = self.direction = 0
		self.bullets = 1

	def shoot(self, start, direction):
		self.rect = Rect(start.topleft, start.size)
		self.shot = 1
		self.direction = direction
		self.bullets = 0
		
	def hide(self):
		self.rect = Rect((-64, -64), (64, 64))
		self.bullets = 1
			
	def update(self, hero):
		if self.direction == 0:
			self.rect.move_ip(0, -10)
		elif self.direction == 1:
			self.rect.move_ip(10, 0)
		elif self.direction == 2:
			self.rect.move_ip(0, 10)
		elif self.direction == 3:
			self.rect.move_ip(-10, 0)
			
		if self.rect.top < 0 or self.rect.top > 576 or self.rect.left < 0 or self.rect.left > 576:
			self.hide()